unit Unit4;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs,
  FMX.Objects, FMX.Edit,
  UnitV ;

type
  TForm4 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Label3: TLabel;
    Edit4: TEdit;
    Label4: TLabel;
    Edit5: TEdit;
    Label5: TLabel;
    Edit6: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Edit7: TEdit;
    Label8: TLabel;
    Edit8: TEdit;
    Label9: TLabel;
    Edit9: TEdit;
    Label10: TLabel;
    Edit10: TEdit;
    Label11: TLabel;
    Edit11: TEdit;
    Line1: TLine;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { private 錾 }
  public
    { public 錾 }
  end;

var
  Form4: TForm4;

implementation

uses
   Unit1 ;

{$R *.fmx}

// N
procedure TForm4.FormShow(Sender: TObject);
begin
   Button1.Enabled := True ;
   Button4.Enabled := True ;
   if not(Form1.SQLConnection1.Connected) then begin
      Button1.Enabled := False ;
      Button4.Enabled := False ;
      exit ;
   end;
   // e[u
   if not(Form1.DataTableCheck(TABLE1)) then
      Form1.DataTableMaking1;

   Edit1.SetFocus ;
end;

// I
procedure TForm4.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   ;
end;

// o^
procedure TForm4.Button1Click(Sender: TObject);
var
   n,i : integer ;
   s : array[0..9] of string ;
begin
   n := SInt(Edit1.Text) ;
   if (n <= 0) then begin
      ShowMessage('o^ԍ1ȏ̐œ͂ĉ');
      Edit1.SetFocus;
      exit;
   end;
   s[0] := Edit2.Text ;
   s[1] := Edit3.Text ;
   s[2] := Edit4.Text ;
   s[3] := Edit5.Text ;
   s[4] := Edit6.Text ;
   s[5] := Edit7.Text ;
   s[6] := Edit8.Text ;
   s[7] := Edit9.Text ;
   s[8] := Edit10.Text ;
   s[9] := Edit11.Text ;
   if (Trim(s[0]) = '') then begin
      ShowMessage('O͂ĉ');
      Edit2.SetFocus;
      exit;
   end;
   for i:=0 to 9 do begin
      if (AnsiPos('''',s[i]) > 0) or (AnsiPos('"',s[i]) > 0) then begin
         ShowMessage('pu''vu"v͂Ȃŉ');
         Edit2.SetFocus;
         exit;
      end;
   end;
   for i:=0 to 9 do begin
      if (s[i] = '') then
         s[i] := 'NULL'
      else
         s[i] := '''' + s[i] + '''' ;
   end;

   with Form1 do begin
      try
         tr := SQLConnection1.BeginTransaction ;

         SQLQuery1.Close;
         SQLQuery1.ParamCheck := False ;
         with SQLQuery1.SQL do begin
            Clear ;
            Add('UPDATE ' + TABLE1 + ' SET');
            Add('  PNAME=' + s[0] + ',');
            Add('  PKANA=' + s[1] + ',');
            Add('  ZIP1='  + s[2] + ',');
            Add('  ZIP2='  + s[3] + ',');
            Add('  ADR1='  + s[4] + ',');
            Add('  ADR2='  + s[5] + ',');
            Add('  TEL='   + s[6] + ',');
            Add('  FAX='   + s[7] + ',');
            Add('  PHONE=' + s[8] + ',');
            Add('  BIKO='  + s[9] );
            Add(' WHERE N=' + IntToStr(n) + ';');
         end;
         if not(SQLQuery1.Prepared) then SQLQuery1.Prepared:=True;
         SQLQuery1.ExecSQL;

         SQLConnection1.CommitFreeAndNil(tr);

         ShowMessage('ҏWo^OK');
      except
         SQLConnection1.RollbackIncompleteFreeAndNil(tr);

         ShowMessage('ҏWo^s');
      end;
      SQLQuery1.Active := False ;

      DataBaseDisConnect ;
      DataBaseConnect ;
   end;

   Button2Click(Sender);
end;

// NA
procedure TForm4.Button2Click(Sender: TObject);
begin
   Edit1.Text := '';
   Edit2.Text := '';
   Edit3.Text := '';
   Edit4.Text := '';
   Edit5.Text := '';
   Edit6.Text := '';
   Edit7.Text := '';
   Edit8.Text := '';
   Edit9.Text := '';
   Edit10.Text := '';
   Edit11.Text := '';
end;

// 
procedure TForm4.Button3Click(Sender: TObject);
begin
   close ;
end;

// f[^擾
procedure TForm4.Button4Click(Sender: TObject);
var
   n,i : integer ;
   s : array[0..10] of string ;
begin
   n := SInt(Edit1.Text) ;
   if (n <= 0) then begin
      ShowMessage('o^ԍ1ȏ̐œ͂ĉ');
      Edit1.SetFocus;
      exit;
   end;

   Button2Click(Sender);
   for i:=0 to 10 do
      s[i] := '' ;

   with Form1 do begin
      SQLQuery1.Active := False ;
      SQLQuery1.ParamCheck := True ;
      with SQLQuery1.SQL do begin
         Clear ;
         Add('SELECT * FROM '+TABLE1+' WHERE N='+IntToStr(n)+';') ;
      end;
      //
      try
         SQLQuery1.Open ;
         SQLQuery1.First ;
         if not(SQLQuery1.Eof) then begin
            for i:=0 to 10 do begin
               s[i] := SQLQuery1.Fields[i].AsString ;
            end;
         end;
      except
         ;
      end;
      SQLQuery1.Active := False ;
   end;

   Edit1.Text  := s[ 0];
   Edit2.Text  := s[ 1];
   Edit3.Text  := s[ 2];
   Edit4.Text  := s[ 3];
   Edit5.Text  := s[ 4];
   Edit6.Text  := s[ 5];
   Edit7.Text  := s[ 6];
   Edit8.Text  := s[ 7];
   Edit9.Text  := s[ 8];
   Edit10.Text := s[ 9];
   Edit11.Text := s[10];

   Edit2.SetFocus ;
end;

end.
