unit Unit2;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs,  FMX.Edit,
  UnitV, Data.DbxSqlite, Data.DB, Data.SqlExpr ;

type
  TForm2 = class(TForm)
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Button1: TButton;
    Button2: TButton;
    SQLConnection1: TSQLConnection;
    OpenDialog1: TOpenDialog;
    Button3: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { private 錾 }
  public
    { public 錾 }
  end;

var
  Form2: TForm2;

implementation

{$R *.fmx}

// N
procedure TForm2.FormShow(Sender: TObject);
begin
   Edit2.Text := DBfold ;
   Edit3.Text := DBname ;
   Edit2.SetFocus ;
end;

// I
procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   ;  //
end;

// OK
procedure TForm2.Button1Click(Sender: TObject);
begin
   DBfold := Edit2.Text ;
   DBname := AnsiUpperCase(Edit3.Text) ;
   if (Trim(DBfold) = '') then begin
      ShowMessage('f[^̃tH_w肵ĉB');
      Edit2.SetFocus;
      exit;
   end;
   if (Trim(DBname) = '') then begin
      ShowMessage('f[^x[Xw肵ĉB');
      Edit3.SetFocus;
      exit;
   end;
   if (ExtractFileExt(DBname) = '') then DBname := DBname + '.S3DB';

   // f[^x[X쐬/ڑ܂
   SQLConnection1.Params.Add('Database='+DBfold+DBname);
   try
      // ڑm
      SQLConnection1.Connected := true;
      SQLConnection1.Connected := False ;
      ShowMessage('f[^x[Xɐڑo܂B');
   except
      ShowMessage('f[^x[Xɐڑo܂łB');
   end;

   close ;
end;

// LZ
procedure TForm2.Button2Click(Sender: TObject);
begin
   close ;
end;

// Q
procedure TForm2.Button3Click(Sender: TObject);
var
   s : string;
begin
   s := Edit2.Text;
   if (Trim(s) = '') then
      s := AppPath
   else if not(DirectoryExists(s)) then
      s := AppPath;

   OpenDialog1.InitialDir := s;
   OpenDialog1.FileName := Edit3.Text;
   if (OpenDialog1.Execute) then begin
      s := OpenDialog1.FileName;
      Edit2.Text := ExtractFilePath(s);
      Edit3.Text := ExtractFileName(s);
   end;
end;

end.
